(declaim (optimize (speed 2) (debug 3) (safety 3)))
#+nil #.(progn (require :alexandria)
	 (require :vector))

(defpackage :vol
  (:use :cl :sb-alien :sb-c-call :vector)
  (:export

    #:read-pgm
    #:write-pgm
    #:histogram
    #:read-stack
    #:linear-regression
    #:clamp
       
    #:do-region
    #:with-slice
   
    #:save-stack-ub8


    #:resample-half
    #:cross-section-xz

    #:count-non-zero-ub8
    
    #:bbox
    #:make-bbox
    #:bbox-start
    #:bbox-end
    
    #:mean

    #:with-arrays

    #:draw-disk
    #:draw-unit-intensity-disk-precise
    #:draw-unit-energy-disk-precise
    #:draw-sphere-ub8
    #:draw-oval-ub8
    
    #:format-symbol
    #:ift
    #:interpolate
    #:convert
    
#:CONVOLVE-NOCROP-2-CSF
#:CONVOLVE-NOCROP-2-CDF
#:CONVOLVE-NOCROP-3-CSF
#:CONVOLVE-NOCROP-3-CDF
#:CONVOLVE-NOCROP
#:CONVOLVE-CIRC-2-CSF
#:CONVOLVE-CIRC-2-CDF
#:CONVOLVE-CIRC-3-CSF
#:CONVOLVE-CIRC-3-CDF
#:CONVOLVE-CIRC
#:DRAW-OVAL-CDF
#:DRAW-OVAL-CSF
#:DRAW-OVAL-DF
#:DRAW-OVAL-SF
#:DRAW-OVAL-UB8
#:DRAW-SPHERE-CDF
#:DRAW-SPHERE-CSF
#:DRAW-SPHERE-DF
#:DRAW-SPHERE-SF
#:DRAW-SPHERE-UB8
#:DRAW-UNIT-ENERGY-DISK-PRECISE-CDF
#:DRAW-UNIT-ENERGY-DISK-PRECISE-CSF
#:DRAW-UNIFORM-DISK-PRECISE-CDF
#:DRAW-UNIFORM-DISK-PRECISE-CSF
#:DRAW-DISK-UB8
#:DRAW-DISK-SF
#:DRAW-DISK-DF
#:DRAW-DISK-CSF
#:DRAW-DISK-CDF
#:FT-1-CSF
#:FT-1-CDF
#:FT-2-CSF
#:FT-2-CDF
#:FT-3-CSF
#:FT-3-CDF
#:FT
#:FFTSHIFT-1-CDF
#:FFTSHIFT-1-CSF
#:FFTSHIFT-2-CDF
#:FFTSHIFT-2-CSF
#:FFTSHIFT-3-CDF
#:FFTSHIFT-3-CSF
#:FFTSHIFT
#:FIND-BBOX-2-UB8
#:FIND-BBOX-2-SF
#:FIND-BBOX-2-DF
#:FIND-BBOX-2-CSF
#:FIND-BBOX-2-CDF
#:FIND-BBOX-3-UB8
#:FIND-BBOX-3-SF
#:FIND-BBOX-3-DF
#:FIND-BBOX-3-CSF
#:FIND-BBOX-3-CDF
#:FIND-BBOX
#:REPLACE-BBOX-2-UB8
#:REPLACE-BBOX-2-SF
#:REPLACE-BBOX-2-DF
#:REPLACE-BBOX-2-CSF
#:REPLACE-BBOX-2-CDF
#:REPLACE-BBOX-3-UB8
#:REPLACE-BBOX-3-SF
#:REPLACE-BBOX-3-DF
#:REPLACE-BBOX-3-CSF
#:REPLACE-BBOX-3-CDF
#:REPLACE-BBOX
#:EXTRACT-BBOX-2-UB8
#:EXTRACT-BBOX-2-SF
#:EXTRACT-BBOX-2-DF
#:EXTRACT-BBOX-2-CSF
#:EXTRACT-BBOX-2-CDF
#:EXTRACT-BBOX-3-UB8
#:EXTRACT-BBOX-3-SF
#:EXTRACT-BBOX-3-DF
#:EXTRACT-BBOX-3-CSF
#:EXTRACT-BBOX-3-CDF
#:EXTRACT-BBOX
#:MEAN-1-UB8
#:MEAN-1-SF
#:MEAN-1-DF
#:MEAN-1-CSF
#:MEAN-1-CDF
#:MEAN-2-UB8
#:MEAN-2-SF
#:MEAN-2-DF
#:MEAN-2-CSF
#:MEAN-2-CDF
#:MEAN-3-UB8
#:MEAN-3-SF
#:MEAN-3-DF
#:MEAN-3-CSF
#:MEAN-3-CDF
#:MEAN
#:.+-1-UB8
#:.--1-UB8
#:.*-1-UB8
#:./-1-UB8
#:.+-1-SF
#:.--1-SF
#:.*-1-SF
#:./-1-SF
#:.+-1-DF
#:.--1-DF
#:.*-1-DF
#:./-1-DF
#:.+-1-CSF
#:.--1-CSF
#:.*-1-CSF
#:./-1-CSF
#:.+-1-CDF
#:.--1-CDF
#:.*-1-CDF
#:./-1-CDF
#:.+-2-UB8
#:.--2-UB8
#:.*-2-UB8
#:./-2-UB8
#:.+-2-SF
#:.--2-SF
#:.*-2-SF
#:./-2-SF
#:.+-2-DF
#:.--2-DF
#:.*-2-DF
#:./-2-DF
#:.+-2-CSF
#:.--2-CSF
#:.*-2-CSF
#:./-2-CSF
#:.+-2-CDF
#:.--2-CDF
#:.*-2-CDF
#:./-2-CDF
#:.+-3-UB8
#:.--3-UB8
#:.*-3-UB8
#:./-3-UB8
#:.+-3-SF
#:.--3-SF
#:.*-3-SF
#:./-3-SF
#:.+-3-DF
#:.--3-DF
#:.*-3-DF
#:./-3-DF
#:.+-3-CSF
#:.--3-CSF
#:.*-3-CSF
#:./-3-CSF
#:.+-3-CDF
#:.--3-CDF
#:.*-3-CDF
#:./-3-CDF
#:./
#:.*
#:.-
#:.+
#:CROSS-SECTION-XZ
#:DECIMATE-XY-CDF
#:DECIMATE-XY-CSF
#:DECIMATE-XY-DF
#:DECIMATE-XY-SF
#:DECIMATE-XY-UB8
#:CROSS-SECTION-XZ-CDF
#:CROSS-SECTION-XZ-CSF
#:CROSS-SECTION-XZ-DF
#:CROSS-SECTION-XZ-SF
#:CROSS-SECTION-XZ-UB8
#:RESAMPLE-1-SF
#:RESAMPLE-1-DF
#:RESAMPLE-1-CSF
#:RESAMPLE-1-CDF
#:RESAMPLE-2-SF
#:RESAMPLE-2-DF
#:RESAMPLE-2-CSF
#:RESAMPLE-2-CDF
#:RESAMPLE-3-SF
#:RESAMPLE-3-DF
#:RESAMPLE-3-CSF
#:RESAMPLE-3-CDF
#:RESAMPLE-HALF-1-UB8
#:RESAMPLE-HALF-1-SF
#:RESAMPLE-HALF-1-DF
#:RESAMPLE-HALF-1-CDF
#:RESAMPLE-HALF-1-CSF
#:RESAMPLE-HALF-2-UB8
#:RESAMPLE-HALF-2-SF
#:RESAMPLE-HALF-2-DF
#:RESAMPLE-HALF-2-CDF
#:RESAMPLE-HALF-2-CSF
#:RESAMPLE-HALF-3-UB8
#:RESAMPLE-HALF-3-SF
#:RESAMPLE-HALF-3-DF
#:RESAMPLE-HALF-3-CDF
#:RESAMPLE-HALF-3-CSF
#:INTERPOLATE-1-SF
#:INTERPOLATE-1-DF
#:INTERPOLATE-1-CSF
#:INTERPOLATE-1-CDF
#:INTERPOLATE-2-SF
#:INTERPOLATE-2-DF
#:INTERPOLATE-2-CSF
#:INTERPOLATE-2-CDF
#:INTERPOLATE-3-SF
#:INTERPOLATE-3-DF
#:INTERPOLATE-3-CSF
#:INTERPOLATE-3-CDF
#:NORMALIZE-1-UB8/UB8
#:NORMALIZE-1-UB8/SF
#:NORMALIZE-1-UB8/DF
#:NORMALIZE-1-SF/UB8
#:NORMALIZE-1-SF/SF
#:NORMALIZE-1-SF/DF
#:NORMALIZE-1-DF/UB8
#:NORMALIZE-1-DF/SF
#:NORMALIZE-1-DF/DF
#:NORMALIZE-2-UB8/UB8
#:NORMALIZE-2-UB8/SF
#:NORMALIZE-2-UB8/DF
#:NORMALIZE-2-SF/UB8
#:NORMALIZE-2-SF/SF
#:NORMALIZE-2-SF/DF
#:NORMALIZE-2-DF/UB8
#:NORMALIZE-2-DF/SF
#:NORMALIZE-2-DF/DF
#:NORMALIZE-3-UB8/UB8
#:NORMALIZE-3-UB8/SF
#:NORMALIZE-3-UB8/DF
#:NORMALIZE-3-SF/UB8
#:NORMALIZE-3-SF/SF
#:NORMALIZE-3-SF/DF
#:NORMALIZE-3-DF/UB8
#:NORMALIZE-3-DF/SF
#:NORMALIZE-3-DF/DF
#:NORMALIZE-1-CSF/UB8-REALPART
#:NORMALIZE-1-CSF/UB8-IMAGPART
#:NORMALIZE-1-CSF/UB8-PHASE
#:NORMALIZE-1-CSF/UB8-ABS
#:NORMALIZE-1-CSF/SF-REALPART
#:NORMALIZE-1-CSF/SF-IMAGPART
#:NORMALIZE-1-CSF/SF-PHASE
#:NORMALIZE-1-CSF/SF-ABS
#:NORMALIZE-1-CSF/DF-REALPART
#:NORMALIZE-1-CSF/DF-IMAGPART
#:NORMALIZE-1-CSF/DF-PHASE
#:NORMALIZE-1-CSF/DF-ABS
#:NORMALIZE-1-CDF/UB8-REALPART
#:NORMALIZE-1-CDF/UB8-IMAGPART
#:NORMALIZE-1-CDF/UB8-PHASE
#:NORMALIZE-1-CDF/UB8-ABS
#:NORMALIZE-1-CDF/SF-REALPART
#:NORMALIZE-1-CDF/SF-IMAGPART
#:NORMALIZE-1-CDF/SF-PHASE
#:NORMALIZE-1-CDF/SF-ABS
#:NORMALIZE-1-CDF/DF-REALPART
#:NORMALIZE-1-CDF/DF-IMAGPART
#:NORMALIZE-1-CDF/DF-PHASE
#:NORMALIZE-1-CDF/DF-ABS
#:NORMALIZE-2-CSF/UB8-REALPART
#:NORMALIZE-2-CSF/UB8-IMAGPART
#:NORMALIZE-2-CSF/UB8-PHASE
#:NORMALIZE-2-CSF/UB8-ABS
#:NORMALIZE-2-CSF/SF-REALPART
#:NORMALIZE-2-CSF/SF-IMAGPART
#:NORMALIZE-2-CSF/SF-PHASE
#:NORMALIZE-2-CSF/SF-ABS
#:NORMALIZE-2-CSF/DF-REALPART
#:NORMALIZE-2-CSF/DF-IMAGPART
#:NORMALIZE-2-CSF/DF-PHASE
#:NORMALIZE-2-CSF/DF-ABS
#:NORMALIZE-2-CDF/UB8-REALPART
#:NORMALIZE-2-CDF/UB8-IMAGPART
#:NORMALIZE-2-CDF/UB8-PHASE
#:NORMALIZE-2-CDF/UB8-ABS
#:NORMALIZE-2-CDF/SF-REALPART
#:NORMALIZE-2-CDF/SF-IMAGPART
#:NORMALIZE-2-CDF/SF-PHASE
#:NORMALIZE-2-CDF/SF-ABS
#:NORMALIZE-2-CDF/DF-REALPART
#:NORMALIZE-2-CDF/DF-IMAGPART
#:NORMALIZE-2-CDF/DF-PHASE
#:NORMALIZE-2-CDF/DF-ABS
#:NORMALIZE-3-CSF/UB8-REALPART
#:NORMALIZE-3-CSF/UB8-IMAGPART
#:NORMALIZE-3-CSF/UB8-PHASE
#:NORMALIZE-3-CSF/UB8-ABS
#:NORMALIZE-3-CSF/SF-REALPART
#:NORMALIZE-3-CSF/SF-IMAGPART
#:NORMALIZE-3-CSF/SF-PHASE
#:NORMALIZE-3-CSF/SF-ABS
#:NORMALIZE-3-CSF/DF-REALPART
#:NORMALIZE-3-CSF/DF-IMAGPART
#:NORMALIZE-3-CSF/DF-PHASE
#:NORMALIZE-3-CSF/DF-ABS
#:NORMALIZE-3-CDF/UB8-REALPART
#:NORMALIZE-3-CDF/UB8-IMAGPART
#:NORMALIZE-3-CDF/UB8-PHASE
#:NORMALIZE-3-CDF/UB8-ABS
#:NORMALIZE-3-CDF/SF-REALPART
#:NORMALIZE-3-CDF/SF-IMAGPART
#:NORMALIZE-3-CDF/SF-PHASE
#:NORMALIZE-3-CDF/SF-ABS
#:NORMALIZE-3-CDF/DF-REALPART
#:NORMALIZE-3-CDF/DF-IMAGPART
#:NORMALIZE-3-CDF/DF-PHASE
#:NORMALIZE-3-CDF/DF-ABS
#:CONVERT-1-UB8/SF-MUL
#:CONVERT-1-UB8/DF-MUL
#:CONVERT-1-UB8/CSF-MUL
#:CONVERT-1-UB8/CDF-MUL
#:CONVERT-1-FIX/SF-MUL
#:CONVERT-1-FIX/DF-MUL
#:CONVERT-1-FIX/CSF-MUL
#:CONVERT-1-FIX/CDF-MUL
#:CONVERT-1-SF/DF-MUL
#:CONVERT-1-SF/CSF-MUL
#:CONVERT-1-SF/CDF-MUL
#:CONVERT-1-DF/CDF-MUL
#:CONVERT-1-CSF/CDF-MUL
#:CONVERT-1-DF/SF-COERCE
#:CONVERT-1-CDF/CSF-COERCE
#:CONVERT-1-SF/UB8-FLOOR
#:CONVERT-1-DF/UB8-FLOOR
#:CONVERT-1-SF/FIX-FLOOR
#:CONVERT-1-DF/FIX-FLOOR
#:CONVERT-1-CSF/SF-REALPART
#:CONVERT-1-CSF/SF-IMAGPART
#:CONVERT-1-CSF/SF-ABS
#:CONVERT-1-CSF/SF-PHASE
#:CONVERT-1-CDF/DF-REALPART
#:CONVERT-1-CDF/DF-IMAGPART
#:CONVERT-1-CDF/DF-ABS
#:CONVERT-1-CDF/DF-PHASE
#:CONVERT-1-CSF/UB8-REALPART
#:CONVERT-1-CSF/UB8-IMAGPART
#:CONVERT-1-CSF/UB8-ABS
#:CONVERT-1-CSF/UB8-PHASE
#:CONVERT-1-CDF/UB8-REALPART
#:CONVERT-1-CDF/UB8-IMAGPART
#:CONVERT-1-CDF/UB8-ABS
#:CONVERT-1-CDF/UB8-PHASE
#:CONVERT-2-UB8/SF-MUL
#:CONVERT-2-UB8/DF-MUL
#:CONVERT-2-UB8/CSF-MUL
#:CONVERT-2-UB8/CDF-MUL
#:CONVERT-2-FIX/SF-MUL
#:CONVERT-2-FIX/DF-MUL
#:CONVERT-2-FIX/CSF-MUL
#:CONVERT-2-FIX/CDF-MUL
#:CONVERT-2-SF/DF-MUL
#:CONVERT-2-SF/CSF-MUL
#:CONVERT-2-SF/CDF-MUL
#:CONVERT-2-DF/CDF-MUL
#:CONVERT-2-CSF/CDF-MUL
#:CONVERT-2-DF/SF-COERCE
#:CONVERT-2-CDF/CSF-COERCE
#:CONVERT-2-SF/UB8-FLOOR
#:CONVERT-2-DF/UB8-FLOOR
#:CONVERT-2-SF/FIX-FLOOR
#:CONVERT-2-DF/FIX-FLOOR
#:CONVERT-2-CSF/SF-REALPART
#:CONVERT-2-CSF/SF-IMAGPART
#:CONVERT-2-CSF/SF-ABS
#:CONVERT-2-CSF/SF-PHASE
#:CONVERT-2-CDF/DF-REALPART
#:CONVERT-2-CDF/DF-IMAGPART
#:CONVERT-2-CDF/DF-ABS
#:CONVERT-2-CDF/DF-PHASE
#:CONVERT-2-CSF/UB8-REALPART
#:CONVERT-2-CSF/UB8-IMAGPART
#:CONVERT-2-CSF/UB8-ABS
#:CONVERT-2-CSF/UB8-PHASE
#:CONVERT-2-CDF/UB8-REALPART
#:CONVERT-2-CDF/UB8-IMAGPART
#:CONVERT-2-CDF/UB8-ABS
#:CONVERT-2-CDF/UB8-PHASE
#:CONVERT-3-UB8/SF-MUL
#:CONVERT-3-UB8/DF-MUL
#:CONVERT-3-UB8/CSF-MUL
#:CONVERT-3-UB8/CDF-MUL
#:CONVERT-3-FIX/SF-MUL
#:CONVERT-3-FIX/DF-MUL
#:CONVERT-3-FIX/CSF-MUL
#:CONVERT-3-FIX/CDF-MUL
#:CONVERT-3-SF/DF-MUL
#:CONVERT-3-SF/CSF-MUL
#:CONVERT-3-SF/CDF-MUL
#:CONVERT-3-DF/CDF-MUL
#:CONVERT-3-CSF/CDF-MUL
#:CONVERT-3-DF/SF-COERCE
#:CONVERT-3-CDF/CSF-COERCE
#:CONVERT-3-SF/UB8-FLOOR
#:CONVERT-3-DF/UB8-FLOOR
#:CONVERT-3-SF/FIX-FLOOR
#:CONVERT-3-DF/FIX-FLOOR
#:CONVERT-3-CSF/SF-REALPART
#:CONVERT-3-CSF/SF-IMAGPART
#:CONVERT-3-CSF/SF-ABS
#:CONVERT-3-CSF/SF-PHASE
#:CONVERT-3-CDF/DF-REALPART
#:CONVERT-3-CDF/DF-IMAGPART
#:CONVERT-3-CDF/DF-ABS
#:CONVERT-3-CDF/DF-PHASE
#:CONVERT-3-CSF/UB8-REALPART
#:CONVERT-3-CSF/UB8-IMAGPART
#:CONVERT-3-CSF/UB8-ABS
#:CONVERT-3-CSF/UB8-PHASE
#:CONVERT-3-CDF/UB8-REALPART
#:CONVERT-3-CDF/UB8-IMAGPART
#:CONVERT-3-CDF/UB8-ABS
#:CONVERT-3-CDF/UB8-PHASE
#:convolve))

;; for i in `cat vol.lisp|grep defconst|cut -d " " -f 2`;do echo \#:$i ;done